



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>liunx  利用nginx 实现负载均衡</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">liunx  利用nginx 实现负载均衡</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 14:03:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一般采用软件实现负载均衡的有Nginx、apache。nginx 近年来使用频繁，其官网上面显示可以承载5万并发访问量，太牛了。</p>
<p>nginx 相比 apache优势明显：Nginx 服务程序比较稳定，原因是采用了的资源分配技术，降低了CPU 与内存的占用率，</p>
<p>所以使用Nginx 程序部署的动态网站环境不仅十分稳定、高效，而且消耗的系统资源也很少<em>。</em></p>
<p>利用nginx实现负载均衡，只需要一个nginx+2个tomcat。</p>
<p><strong>第一步:安装nginx</strong></p>
<p>liunx上面安装nginx较windows麻烦，依赖openssl、zlib、pcre库。</p>
<p>openssl库 下载地址：<a href="http://www.openssl.org/" rel="external nofollow noreferrer">http://www.openssl.org/</a></p>
<p>zlib库，下载地址：<a href="http://www.zlib.net/" rel="external nofollow noreferrer">http://www.zlib.net/</a>&nbsp; &nbsp; &nbsp;我下载的是&nbsp;zlib-1.2.9.tar.gz</p>
<p>pcre库，下载地址：<a href="http://www.pcre.org/" rel="external nofollow noreferrer">http://www.pcre.org/</a>&nbsp; 我下载的是&nbsp;pcre-8.40.tar.gz</p>
<p>将 这三个压缩文件解压到usr/local 目录下 进行安装，安装比较简单，基本操作就是 解压tar ，./configure&nbsp; ， make ，make install。</p>
<p>在安装pcre-8.40 时候 如果出现这样的错误</p>
<pre class="prettyprint linenums">configure: error: You need a C++ compiler for C++ support<br />要首先安装gcc-c++</pre>
<pre class="prettyprint linenums">yum install -y gcc gcc-c++</pre>
<p>安装 完毕后，开始安装nginx。</p>
<p>在/usr/local目录下解压&nbsp;nginx-1.10.3.tar.gz</p>
<p>tar&nbsp;&nbsp;-zxvf&nbsp;&nbsp;nginx-1.10.3.tar.gz</p>
<p>cd&nbsp;nginx-1.10.3</p>
<p>./configure&nbsp;--sbin-path=/usr/local/nginx/sbin/nginx&nbsp;&nbsp;--conf-path=/usr/local/nginx/conf/nginx.conf&nbsp;--pid-path=/usr/local/nginx/sbin/nginx.pid&nbsp;--with-http_ssl_module&nbsp;--with-pcre=../pcre-8.40 --with-zlib=../zlib-1.2.9</p>
<p>可能会报错</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1286517/201807/1286517-20180703170014843-1214349614.png" /></p>
<p>安装</p>
<pre class="prettyprint linenums">yum -y install openssl openssl-devel<br />重新编译</pre>
<p>make</p>
<p>make install</p>
<p>安装完毕，检查安装是否成功</p>
<p>/usr/local/nginx/sbin/nginx&nbsp;-t</p>
<p>截图如下</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1286517/201801/1286517-20180103110131456-1272852880.png" /></p>
<p><strong>第二步：修改配置文件</strong></p>
<p>为了搭建负载均衡环境，需要修改nginx的配置文件</p>
<p>切到/usr/local/nginx-1.10.3/conf 目录下</p>
<p>vi nginx.conf</p>
<p>添加一些内容</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1286517/201801/1286517-20180103111328471-1813048002.png" /></p>
<p>修改完毕，暂且不启动</p>
<p><strong>第三步：安装tomcat</strong></p>
<p>安装两个tomcat,同一安装在/usr/local/tomcat下面，将其中一个tomcat的server.xml中的tomcat端口号换为8081。</p>
<p>这样两个tomcat端口号一个为8080另一个为8081.端口号无所谓，只需要这两个tomcat能够正常启动。</p>
<p>启动三个软件，启动nginx</p>
<p>/usr/local/nginx/sbin/nginx&nbsp;-c&nbsp;/usr/local/nginx/conf/nginx.conf</p>
<p>查看启动情况</p>
<p><strong><em>netstat -anp | grep :80</em></strong></p>
<p><strong><em>截图如下</em></strong></p>
<p><strong><em><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1286517/201801/1286517-20180103112145393-1230303302.png" /></em></strong></p>
<p>启动两个tomcat</p>
<p><strong>第四步：检测结果</strong></p>
<p>便于看着效果，我将其中一个tomcat下面的root中的index.jsp 加了一个&ldquo;你好&ldquo;。</p>
<p>检测最后效果在浏览器中打开自己服务器的ip</p>
<p>打开其种一个tomcat 8080</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1286517/201801/1286517-20180103112339503-2120254865.png" /></p>
<p>打开另一个tomcat 8081</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1286517/201801/1286517-20180103112453737-26295112.png" /></p>
<p>最后请求nginx,看看能不能两个tomcat之间来回切换</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1286517/201801/1286517-20180103112612268-1876525769.png" /></p>
<p>这个是启动了8080 tomcat，再次刷新浏览器</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1286517/201801/1286517-20180103112717346-1311012748.png" /></p>
<p>这次启动了8081tomcat，表明负载均衡搭建成功。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq47yjnq.html">Asp&period;net操作cookie大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvj3myq.html">插入排序-java</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m65d09.html">linux 安装程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvwwe19.html">IUS</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7y17jq.html">Anchor 对象和document对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvveezzq.html">使用Git上传本地项目代码到github</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xp3x09.html">win7防火墙打不开&lpar;无法启动windows firewall服务&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmk37e9.html">Java API &mdash;&mdash; 泛型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmxm269.html">tomcat的几种部署方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w6773q.html">SQL中not and or优先级问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ywjxjq.html">FireMonkey vs&period; VCL （FMX的UI更灵活，图形效果更强，硬件加速，内嵌3D，使用浮点数更精确，跨平台，可使用Mida converter转换和TFireMonkeyContainer内嵌）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmvzg79.html">上海Uber优步司机奖励政策（1月18日~1月24日）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zm7lg9.html">C&plus;&plus;学习之路&mdash;运算符重载（一）概念、方法及规则</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdxvmy9.html">iOS多线程&mdash;&mdash;同步异步串行并行</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kn5l59.html">java1环境与简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rglxd78.html">Hibernate初体验及简单错误排除</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1kr0dq.html">获取Iframe页面高度并赋值给Iframe以及获取iframe里的元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gen0ye8.html">输入参数的默认值设定&dollar;&lbrace;3&colon;-var&lowbar;d&rcub;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjmy269.html">extern C小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjkzwl9.html">个人博客作业&lowbar;week7</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv2zoey9.html">三、文件IO&mdash;&mdash;系统调用（续）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj40ge9.html">Hyperic-Sigar简介&mdash;&mdash;检测与监控</a>
			</li>
						<li><a href="https://www.batexi.com/a/9607wdy9.html">jmeter负载机运行&sol;添加压力机&sol;分布式</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ol5we8.html">如何发布自己的 jar 包到 maven 中央仓库（待更新&period;&period;&period;）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2l0krq.html">Flask里面的cookie的基本操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1ve25q.html">&lpar;7&rpar;Java数据结构--集合map&comma;set&comma;list详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1n5lg9.html">MySql 在cmd下的学习笔记 &mdash;&mdash; 有关用户权限的操作（grant）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25mo0vq.html">第五节，K-近邻算法（KNN）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv513l8.html">ffmpeg笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rjod39.html">MySql DDL语言（数据库和数据表的管理）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
